module inner_func
Implicit None
contains
Subroutine sub_eval_gas(gas_pars,x1_pos,y1_pos,vobs,evobs,&
mge_surf,mge_sigma,mge_qobs,mge_surf_HI,mge_sigma_HI,mge_qobs_HI,&
distance,incl0,inc_min,PA0,vsys0,chisq1)
!Called by emcee for sampling posterior of gas-based distribution.
!This version puts the the DM center as two final parameters in the gas_pars
!list, as opposed to them being fixed in the older, rot_cur_fit4 version.
use rot_cur_mod
IMPLICIT NONE
Integer::iMC,n_data,n_mge,n0_HI,nmax,ngauss
Parameter(nmax=15)
!Parameter(iMC=9)
Real::gas_pars(:),x0,y0,x1_pos(:),y1_pos(:),vobs(:),&
evobs(:),mge_surf(:),mge_sigma(:),mge_qobs(:),mge_surf_HI(:),mge_sigma_HI(:),&
mge_qobs_HI(:),distance,incl0,PA0,vsys0,chisq1,c_exp,inc_min,surf_tmp(nmax),sigma_tmp(nmax),&
qobs_tmp(nmax),qi_tmp(nmax),lum_tmp(nmax),pc_now,rmin,rmax,rjunk1
Real::inc_go
Real,allocatable,dimension(:)::prior_pars,r_pos,psi_pos,v_stel,v_dm,v_circ,v_HI
Integer::i,j,jlo
Real::dm_params(3)

n_data=size(x1_pos)
n_mge=size(mge_surf)
n0_HI=size(mge_surf_HI)
iMC=size(gas_pars)
Allocate(prior_pars(iMC),r_pos(n_data),psi_pos(n_data),v_stel(n_data),v_dm(n_data),v_circ(n_data),&
v_HI(n_data))
chisq1=0.0
prior_pars(1)=10.**gas_pars(1) !constant in dM200, parameter is log(M200)
!prior_pars(1)=10.**gas_pars(1) !constant in dM200, parameter is log(M200)
!prior_pars(1)=exp(-0.5*((gas_pars(1)-11.17)/0.363)**2)
!prior_pars(1)=1.0
prior_pars(2)=1.0
!c_exp=9.6*(10.**gas_pars(1)/1.857d12)**(-0.075) !Klypin+11
!prior_pars(2)=exp(-0.5*((gas_pars(2)-c_exp)/(0.3454*c_exp))**2)
!Delta_log10c=0.15 per Coe'10
prior_pars(3)=1.0
prior_pars(4)=1.0
!prior_pars(4)=exp(-0.5*((gas_pars(4)-1.0)/0.3)**2)
prior_pars(5)=exp(-0.5*((gas_pars(5)-incl0)/4.0)**2)
prior_pars(6)=exp(-0.5*((gas_pars(6)-PA0)/4.0)**2)
prior_pars(7)=exp(-0.5*((gas_pars(7)-vsys0)/10.0)**2)
prior_pars(8)=exp(-0.5*((gas_pars(8))/3.0)**2) !a crude guess, tied to the
!initial (luminous) position
prior_pars(9)=exp(-0.5*((gas_pars(9))/3.0)**2)
prior_pars(10)=exp(-0.5*((gas_pars(10)-5.0)/5.0)**2)
x0=gas_pars(8)
y0=gas_pars(9)
!Open(37,file="debug1.txt",position="append")
!write(37,*) gas_pars(:)
inc_go=max(inc_min,gas_pars(5))
call deproj_pos(n_data,x1_pos,y1_pos,x0,y0,gas_pars(6),inc_go,r_pos,psi_pos)
call mge_circ_vel(n_mge,mge_surf,mge_sigma,mge_qobs,inc_go,distance,n_data,&
r_pos,v_stel)
call mge_circ_vel(n0_HI,mge_surf_HI,mge_sigma_HI,mge_qobs_HI,inc_go,distance,n_data,&
r_pos,v_HI)
dm_params(1)=10.0**gas_pars(1)
dm_params(2)=gas_pars(2)
dm_params(3)=gas_pars(3)
!dm_params(3)=0.6
!write(37,*) gas_pars(:)
!write(37,*) dm_params(:)
!close(37)
pc_now=distance*my_pi/0.648
rmin=max(pc_now*minval(r_pos)/10.0,10.0) !min 10 pc size
rmax=pc_now*maxval(r_pos)*10.0

call gNFW_mge(gas_pars(2),dm_params(1),gas_pars(3),rmin,rmax,ngauss,surf_tmp,sigma_tmp,qobs_tmp)

Do i=1,ngauss
   sigma_tmp(i)=sigma_tmp(i)/pc_now !put into arcsec
End Do

!L=2*pi*I'*sig^2
!Subroutine solve_qmge(n_mge,l_mge,sig_mge,q_mge,qlow,qhigh,qscale)
!After getting intrinsic axial ratios, put into obs and change I normalization

!Do i=1,ngauss
!   lum_tmp(i)=2.0*my_pi*surf_tmp(i)*sigma_tmp(i)**2
!End Do
!call solve_qmge(ngauss,lum_tmp,sigma_tmp,qi_tmp,1.6,0.4,40.0)
!Do i=1,ngauss
!   qobs_tmp(i)=sqrt((qi_tmp(i)*sin(incl1*my_pi/180.0))**2+cos(incl1*my_pi/180.0)**2)
!   surf_tmp(i)=surf_tmp(i)/qobs_tmp(i)
!End Do
Do i=1,ngauss
   qobs_tmp(i)=1.0
End Do
call mge_circ_vel(ngauss,surf_tmp,sigma_tmp,qobs_tmp,inc_go,distance,n_data,&
r_pos,v_dm)
!call func_sing_velrot(3,dm_params,n_data,r_pos,v_dm,distance)
!Evaluate likelihood grid


!Open(74,file="hid1.txt")
Open(74,file="hid2.txt")
rjunk1=0.0
Do i=1,n_data
   v_circ(i)=sqrt(v_HI(i)**2+gas_pars(4)*v_stel(i)**2+v_dm(i)**2)*&
cos(psi_pos(i))*sin(inc_go*my_pi/180.0)+gas_pars(7)
   chisq1=chisq1-0.5*((v_circ(i)-vobs(i))/(evobs(i)+gas_pars(10)))**2-log(evobs(i)+gas_pars(10))
   rjunk1=rjunk1+((v_circ(i)-vobs(i))/(evobs(i)+gas_pars(10)))**2
!!   write(74,*) r_pos(i), psi_pos(i), vobs(i), evobs(i), v_circ(i), v_dm(i), &
!!   write(74,*) x1_pos(i), y1_pos(i), vobs(i), evobs(i), v_circ(i), v_dm(i), &
!   write(74,*) r_pos(i), psi_pos(i), vobs(i), evobs(i), v_circ(i), v_dm(i), &
!   write(74,*) x1_pos(i), y1_pos(i), vobs(i), evobs(i), v_circ(i), v_dm(i), &
   write(74,*) -sin(gas_pars(6)*(my_pi/180.0))*(x1_pos(i)-x0)+cos(gas_pars(6)*(my_pi/180.0))*(y1_pos(i)-y0), &
-cos(gas_pars(6)*(my_pi/180.0))*(x1_pos(i)-x0)-sin(gas_pars(6)*(my_pi/180.0))*(y1_pos(i)-y0), &
vobs(i), evobs(i)+gas_pars(10), v_circ(i), v_dm(i), &
sqrt(v_HI(i)**2+gas_pars(4)*v_stel(i)**2+v_dm(i)**2)
End Do
Close(74)
!write(*,*) "Chisq and nu ", rjunk1, n_data

Do i=1,iMC
   chisq1=chisq1+log(prior_pars(i))
End Do

!write(*,*) chisq1
!stop


Deallocate(prior_pars,r_pos,psi_pos,v_stel,v_dm,v_circ,v_HI)
return
End Subroutine
end module inner_func
