#!/usr/bin/python
import numpy as np, ctypes
import vwgas as vw
import emcee
import matplotlib.pyplot as pl
import scipy as sp
from scipy import stats
import argparse

parser = argparse.ArgumentParser()
parser.add_argument("InFile", help="Input file containing setup data for a galaxy.")
args = parser.parse_args()
fl_mge=args.InFile
#fl_mge='vlos_mge.in'
distance=0.0
incl=0.0
PA=0.0
vsys=0.0
vsyserr=2.0
#import galaxy data including mge terms
n_mge=0
n_HI_mge=0
i_MC=9
f = open(fl_mge, 'r')
line = f.readline()
nm_prefix=line.split()[0]
fl_dat=nm_prefix+'_vlos_fit4.in'
fl_HI=nm_prefix+'_vHI_mge.in'
line = f.readline()
cline=line.split()
distance=float(cline[0])
incl=float(cline[1])
PA=float(cline[2])
vsys=float(cline[3])
line = f.readline()
n_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_mge_surf=np.array(line.split(),dtype=np.double)
#convert python array to c-style array
#mge_surf=(ctypes.c_double*len(pl_mge_surf))(*pl_mge_surf)
line = f.readline()
pl_mge_sigma=np.array(line.split(),dtype=np.double)
#mge_sigma=(ctypes.c_double*len(pl_mge_sigma))(*pl_mge_sigma)
line = f.readline()
pl_mge_qobs=np.array(line.split(),dtype=np.double)
#mge_qobs=(ctypes.c_double*len(pl_mge_qobs))(*pl_mge_qobs)
f.close()
#mge_surf=np.array(pl_mge_surf)
#mge_sigma=np.array(pl_mge_sigma)
#mge_qobs=np.array(pl_mge_qobs)
mge_surf=pl_mge_surf
mge_sigma=pl_mge_sigma
mge_qobs=pl_mge_qobs
#import kinematic data
n_data=0
f = open(fl_dat, 'r')
pl_x1_pos=[]
pl_y1_pos=[]
pl_vobs=[]
pl_evobs=[]
for line in f:
    line = line.strip()
    columns = line.split()
    pl_x1_pos.append(float(columns[0]))
    pl_y1_pos.append(float(columns[1]))
    pl_vobs.append(float(columns[3]))
    pl_evobs.append(float(columns[4]))
f.close()
n_data=len(pl_x1_pos)
x1_pos=np.array(pl_x1_pos)
y1_pos=np.array(pl_y1_pos)
vobs=np.array(pl_vobs)
evobs=np.array(pl_evobs)+np.ones(n_data)*vsyserr
#x1_pos=(ctypes.c_double*len(pl_x1_pos))(*pl_x1_pos)
#y1_pos=(ctypes.c_double*len(pl_y1_pos))(*pl_y1_pos)
#vobs=(ctypes.c_double*len(pl_vobs))(*pl_vobs)
#evobs=(ctypes.c_double*len(pl_evobs))(*pl_evobs)
#import HI data
f = open(fl_HI, 'r')
line = f.readline()
n_HI_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_surf_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_sigma_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_qobs_mge_HI=np.array(line.split(),dtype=np.double)
f.close()
surf_mge_HI=pl_surf_mge_HI
sigma_mge_HI=pl_sigma_mge_HI
qobs_mge_HI=pl_qobs_mge_HI
#r0_HI=(ctypes.c_double*len(pl_r0_HI))(*pl_r0_HI)
#v0_HI=(ctypes.c_double*len(pl_v0_HI))(*pl_v0_HI)
gas_pars0=np.array([10.5,17.0,0.1,1.0,incl,PA,vsys,0.0,0.0])
sig_gas_pars=np.array([0.8,3.0,0.3,0.3,0.2,5.0,5.0,3.0,3.0])
#logM200,c,gamma,upsilon,i,PA,vsys,x0,y0
out1=0.0
#gas_pars0=(ctypes.c_double*len(pl_gas_pars0))(*pl_gas_pars0)
#print gas_pars0
#chisq1=vw.sub_eval_gas(gas_pars0,x1_pos,y1_pos,vobs,evobs,
#mge_surf,mge_sigma,mge_qobs,distance,incl,PA,vsys,r0_HI,v0_HI,out1)

ndim=len(gas_pars0)
nwalkers = 250
p0 = 1.0-2.0*np.random.rand(ndim * nwalkers).reshape((nwalkers, ndim))
p0=np.dot(p0,np.diag(sig_gas_pars))+gas_pars0
p0[:,4]+=sig_gas_pars[4]

#for N959 gas
#pars_go=np.array([11.043147,17.411817,0.82614903,1.1119900,54.951732,61.822627,598.38397,0.38447260,-0.0074752621])
#for N959 stars
pars_go=np.array([11.416998,18.140287,0.82775247,1.0130802,54.951894,65.015497,595.37291,-0.19918449,-0.016862593])
#pars_go=np.array([11.300528220900000,18.666359111900000,0.76308329131399999,1.2156560261200000,55.004749928400003,66.154151123600002,594.47365992499999,-1.0934401014199999,-0.95300962481200002])

junk_c1=vw.sub_eval_gas(pars_go,x1_pos,y1_pos,
vobs,evobs,mge_surf,mge_sigma,mge_qobs,surf_mge_HI,sigma_mge_HI,qobs_mge_HI,
distance,incl,PA,vsys,out1)

