#!/usr/bin/python
import numpy as np, ctypes
import vwgas as vw
import emcee
import matplotlib.pyplot as pl
import scipy as sp
from scipy import stats
import argparse

parser = argparse.ArgumentParser()
parser.add_argument("InFile", help="Input file containing setup data for a galaxy.")
args = parser.parse_args()
fl_mge=args.InFile
#fl_mge='vlos_mge.in'
distance=0.0
incl=0.0
PA=0.0
vsys=0.0
vsyserr=2.0
#import galaxy data including mge terms
n_mge=0
n_HI_mge=0
i_MC=9
f = open(fl_mge, 'r')
line = f.readline()
nm_prefix=line.split()[0]
fl_dat=nm_prefix+'_vlos_fit4.in'
fl_HI=nm_prefix+'_vHI_mge.in'
fl_out=nm_prefix+'_pdf_sample.out'
line = f.readline()
cline=line.split()
distance=float(cline[0])
incl=float(cline[1])
PA=float(cline[2])
vsys=float(cline[3])
line = f.readline()
n_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_mge_surf=np.array(line.split(),dtype=np.double)
#convert python array to c-style array
#mge_surf=(ctypes.c_double*len(pl_mge_surf))(*pl_mge_surf)
line = f.readline()
pl_mge_sigma=np.array(line.split(),dtype=np.double)
#mge_sigma=(ctypes.c_double*len(pl_mge_sigma))(*pl_mge_sigma)
line = f.readline()
pl_mge_qobs=np.array(line.split(),dtype=np.double)
#mge_qobs=(ctypes.c_double*len(pl_mge_qobs))(*pl_mge_qobs)
f.close()
#mge_surf=np.array(pl_mge_surf)
#mge_sigma=np.array(pl_mge_sigma)
#mge_qobs=np.array(pl_mge_qobs)
mge_surf=pl_mge_surf
mge_sigma=pl_mge_sigma
mge_qobs=pl_mge_qobs
#import kinematic data
n_data=0
f = open(fl_dat, 'r')
pl_x1_pos=[]
pl_y1_pos=[]
pl_vobs=[]
pl_evobs=[]
for line in f:
    line = line.strip()
    columns = line.split()
    pl_x1_pos.append(float(columns[0]))
    pl_y1_pos.append(float(columns[1]))
    pl_vobs.append(float(columns[3]))
    pl_evobs.append(float(columns[4]))
f.close()
n_data=len(pl_x1_pos)
x1_pos=np.array(pl_x1_pos)
y1_pos=np.array(pl_y1_pos)
vobs=np.array(pl_vobs)
evobs=np.array(pl_evobs)+np.ones(n_data)*vsyserr
#x1_pos=(ctypes.c_double*len(pl_x1_pos))(*pl_x1_pos)
#y1_pos=(ctypes.c_double*len(pl_y1_pos))(*pl_y1_pos)
#vobs=(ctypes.c_double*len(pl_vobs))(*pl_vobs)
#evobs=(ctypes.c_double*len(pl_evobs))(*pl_evobs)
#import HI data
f = open(fl_HI, 'r')
line = f.readline()
n_HI_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_surf_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_sigma_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_qobs_mge_HI=np.array(line.split(),dtype=np.double)
f.close()
surf_mge_HI=pl_surf_mge_HI
sigma_mge_HI=pl_sigma_mge_HI
qobs_mge_HI=pl_qobs_mge_HI
#r0_HI=(ctypes.c_double*len(pl_r0_HI))(*pl_r0_HI)
#v0_HI=(ctypes.c_double*len(pl_v0_HI))(*pl_v0_HI)
gas_pars0=np.array([10.0,17.0,0.6,1.0,incl,PA,vsys,0.0,0.0])
sig_gas_pars=np.array([0.5,3.0,0.3,0.3,0.2,5.0,5.0,3.0,3.0])
#logM200,c,gamma,upsilon,i,PA,vsys,x0,y0
out1=0.0
#gas_pars0=(ctypes.c_double*len(pl_gas_pars0))(*pl_gas_pars0)
#print gas_pars0
#chisq1=vw.sub_eval_gas(gas_pars0,x1_pos,y1_pos,vobs,evobs,
#mge_surf,mge_sigma,mge_qobs,distance,incl,PA,vsys,r0_HI,v0_HI,out1)

ndim=len(gas_pars0)
nwalkers = 250
p0 = 1.0-2.0*np.random.rand(ndim * nwalkers).reshape((nwalkers, ndim))
p0=np.dot(p0,np.diag(sig_gas_pars))+gas_pars0
p0[:,4]+=sig_gas_pars[4]

gas_pars0=np.array([11.85,23.4,0.35,1.08,61.9,150.3,443.3,0.0,0.0])
v1=vw.sub_eval_gas(gas_pars0,x1_pos,y1_pos,
vobs,evobs,mge_surf,mge_sigma,mge_qobs,surf_mge_HI,sigma_mge_HI,qobs_mge_HI,
distance,incl,PA,vsys,out1)
exit()

sampler=emcee.EnsembleSampler(nwalkers,ndim,vw.sub_eval_gas,args=[x1_pos,y1_pos,
vobs,evobs,mge_surf,mge_sigma,mge_qobs,surf_mge_HI,sigma_mge_HI,qobs_mge_HI,
distance,incl,PA,vsys,out1],threads=6)
nburn=30

pos, prob, stat = sampler.run_mcmc(p0,nburn)
sampler.reset()
nrun=300
nplsamp=21
sampler.run_mcmc(pos,nrun)

xlab1=[r'log $M_{200}$',r'c',r'$\gamma$',r'$\Upsilon$',r'i (deg)',r'PA (deg)',
r'$v_{sys} (km/s)$',r'$x_0$ (")',r'$y_0$ (")']
fl_out1=sampler.flatchain
for i in range(i_MC):
    pl.figure(i)
    pl.clf()
    pl.xlabel(xlab1[i])
    pl.ylabel('N')
    pl.hist(fl_out1[:,i], 100, color="k", histtype="step")
    pl.savefig(nm_prefix+'_gas_p{0:02d}.eps'.format(i+1))

fo=open(fl_out,"w")
for i in range(nrun*nwalkers):
   fo.write("{0} {1} {2} {3} {4} {5} {6} {7} {8}\n".format(fl_out1[i,0],
   fl_out1[i,1],fl_out1[i,2],fl_out1[i,3],
   fl_out1[i,4],fl_out1[i,5],fl_out1[i,6],
   fl_out1[i,7],fl_out1[i,8]))
fo.close()

c_lev=100.0*2.0*stats.norm.sf([1.0,2.0,3.0],loc=0.0,scale=1.0)
ccnt1=0
for i in range(i_MC-1):
   tmpl1=[x for x in range(i_MC) if x > i]
   for j in tmpl1:
      ccnt1+=1
      Hout2d, edges2dx, edges2dy = np.histogram2d(fl_out1[:,i],fl_out1[:,j],bins=[nplsamp for x in range(2)])
      xrng1=(edges2dx[0:nplsamp]+edges2dx[1:nplsamp+1])/2.0
      xrng2=(edges2dy[0:nplsamp]+edges2dy[1:nplsamp+1])/2.0
      twolnl=Hout2d/(nwalkers*nrun)
      twolnl[twolnl <= 0.0]=1.E-20
      twolnl=-2.0*np.log(twolnl)
      twolnl=twolnl-min(twolnl.flat) #makes ~delta_chisq variable
      cum_pdf=100.*stats.chi2.sf(twolnl,2.0)
#Hout2d, edges2d = np.histogramdd(fl_out1,bins=[nplsamp for x in range(ndim)])
      pl.figure()
#xrng1=(edges[0][0:nplsamp]+edges[0][1:nplsamp+1])/2.0
#xrng2=(edges[1][0:nplsamp]+edges[1][1:nplsamp+1])/2.0
      x2v,x1v=np.meshgrid(xrng2,xrng1)

#marg_l1=np.array([8,7,6,5,4,3,2])
#Htrim2d=Hout2d
#for i in marg_l1:
#   Htrim2d=np.sum(Htrim2d,axis=i)
#-2loge(LR) is chisq distributed. Useful for confidence intervals.
      CS = pl.contour(x1v,x2v,cum_pdf,c_lev)
      pl.xlabel(xlab1[i])
      pl.ylabel(xlab1[j])
      pl.clabel(CS, inline=1, fontsize=10)
#      pl.title('Simplest default with labels')
      pl.savefig(nm_prefix+'_contour{0:02d}.eps'.format(ccnt1))

#fl_out=nm_prefix+'pdf_sample.out'
    #pl.hist(fl_out1[:,i], 100, color="k", histtype="step")
print("Mean acceptance fraction: {0:.3f}".format(np.mean(sampler.acceptance_fraction)))
