Pro debug_kin
compile_opt idl2
;Three panel plot of kinematics, with borders trimmed.
;Program to autoscale and plot rot, disp, and 2nd moment velocities for 
;VW data. Takes input in the form of mindata_*.in. Also plots original 
;S/N value per fiber from bundle_voronoi.out.
sauron_colormap

;Must manually adjust for correct galaxy MGE model
ML_sol = 4.42 ; solar M/L in R band, from Binney and Merrifield, for 
fib_rad=1.56d0
;ML_sol = 3.280 ; solar M in 3.6um WISE band,Vega, from www.mancone.net/ezgal/filters.php, for U11707 and U2259

;NGC 2976
;surf_lum = [2298.3470,68.851126,27.769026,117.76896,19.550785]
;sigma_lum = [0.280440,0.986237,6.35659,49.8893,108.260]
;qobs_lum = [0.990000,0.990000,0.990000,0.480000,0.542514]
;NGC 5204
;surf_lum = [79.358771,167.54775,373.80745,153.55340,17.988999]
;sigma_lum = [1.82877,2.64500,10.4181,24.9752,53.1560]
;qobs_lum = [0.656000,0.999900,0.656000,0.656000,0.656000]
;NGC 5949
;surf_lum = [2063.8686,344.45543,740.10477,65.783171,7.8937599]
;sigma_lum = [0.342634,1.88371,9.67716,14.5614,32.5872]
;qobs_lum = [0.999900,0.656000,0.656000,0.656000,0.656000]
;for UGC2002
surf_lum = [1550.9592,100.53954,135.54679,5.9983988]
sigma_lum = [0.345098,4.05466,23.1474,52.3390]
qobs_lum = [0.823000,0.990000,0.656000,0.656000]
;UGC2259
;ML_sol = 3.280 ; solar M in 3.6um WISE band,Vega, from www.mancone.net/ezgal/filters.php
;surf_lum = [165.22446,44.407364,78.222171,8.8834059]
;sigma_lum = [3.09375,10.2070,33.1140,90.2989]
;qobs_lum = [0.949977,0.999900,0.900053,0.999900]
;UGC11707
;ML_sol = 3.280 ; solar M in 3.6um WISE band,Vega, from www.mancone.net/ezgal/filters.php
;surf_lum = [18.800685,18.705804,18.752806,18.765408,18.732173]
;sigma_lum = [0.600000,2.99815,10.6359,27.4743,77.8474]
;qobs_lum = [0.872500,0.990000,0.755000,0.755000,0.755000]
;UGC4325
;surf_lum = [18.800685,18.705804,18.752806,18.765408,18.732173]
;sigma_lum = [0.600000,2.99815,10.6359,27.4743,77.8474]
;qobs_lum = [0.872500,0.990000,0.755000,0.755000,0.755000]
vsys=594.55
PA_gal=154.0*!dpi/180d0 ;this angle is really PA +90
;file1_gas='mock_vlos_U2002.dat'
file1_gas='hid2.txt'
readcol, file1_gas, del_ra, del_dec,v_dgas,vdmod, format='(D,D,D,X,D)'
v_gas=v_dgas-vdmod
rot_ra=del_ra*cos(PA_gal)+del_dec*sin(PA_gal)
rot_dec=del_dec*cos(PA_gal)-del_ra*sin(PA_gal)
;rot_ra=del_ra
;rot_dec=del_dec

nelm_vel=n_elements(v_gas)
ind_vel=sort(v_gas)
gvelmin=v_gas[ind_vel[nint(0.05*nelm_vel)]]
gvelmax=v_gas[ind_vel[nint(0.95*nelm_vel)]]
gvelmed=v_gas[ind_vel[nint(0.5*nelm_vel)]]

fibxmax=max([rot_ra],MIN=fibxmin)
fibymax=max([rot_dec],MIN=fibymin)
fib_xrange=[fibxmin-fib_rad,fibxmax+fib_rad]
fib_yrange=[fibymin-fib_rad,fibymax+fib_rad]
vel_range=[1.1d0*(gvelmin-gvelmed)+gvelmed,1.1d0*(gvelmax-gvelmed)+gvelmed]

pl_max_y=max(fib_yrange)-1d0
pl_min_y=min(fib_yrange)+1d0
pl_max_x=max(fib_xrange)-8d0
pl_max_x2=max(fib_xrange)+2d0
pl_min_x=min(fib_xrange)+2d0

set_plot, 'ps'
;device, /encapsulated, filename='mock_dirplot_UGC2002.eps',/color, XSIZE=11.5, YSIZE=15
device, /encapsulated, filename='debug_kin.eps',/color, XSIZE=12.7, YSIZE=15
ncolors=128
!x.tickformat='(A1)'
!y.tickformat='(A1)'
!x.margin=[0,0]
!y.margin=[0,0]
!x.omargin=[6.6,2]
!y.omargin=[4,0]
!P.CHARSIZE=3.0
!P.CHARTHICK=1.5

display_fibers_range, rot_ra, rot_dec, v_gas, fib_xrange,fib_yrange, FIBERSIZE=fib_rad, RANGE=vel_range
;display_fibers_axes, rot_ra, rot_dec, v_gas, fib_xrange,fib_yrange, FIBERSIZE=fib_rad, RANGE=vel_range
dev_pos_1=convert_coord(fib_xrange[0],fib_yrange[0],/data,/to_device)
dev_pos_2=convert_coord(fib_xrange[1],fib_yrange[1],/data,/to_device)
norm_pos_1=convert_coord(pl_max_x2,pl_min_y,/to_normal)
norm_pos_2=convert_coord(pl_max_x2,pl_max_y,/to_normal)
oplotcompass, [dev_pos_1[0],dev_pos_1[1],dev_pos_2[0],dev_pos_2[1]], rotang=-(180d/!dpi)*PA_gal, charsize=0.5
cap_colorbar, position=[norm_pos_1[0,0],norm_pos_1[1,0],norm_pos_2[0,0]+5d-2,norm_pos_2[1,0]], /VERTICAL, /RIGHT, $
RANGE=vel_range, TITLE='V!Dgas!N (km/s)', divisions=3, charsize=3.0

device, /close
set_plot, 'x'



END
