#!/usr/bin/python
import numpy as np, ctypes
import vwgas as vw
import emcee
import matplotlib.pyplot as pl
import scipy as sp
from scipy import stats
import argparse
import time
import random

parser = argparse.ArgumentParser()
parser.add_argument("InFile", help="Input file containing setup data for a galaxy.")
#parser.add_argument("sigin", help="Addditional sigma.",type=float)
args = parser.parse_args()
fl_mge=args.InFile
#sigsys=args.sigin

#fl_mge='vlos_mge.in'
vsyserr=2.0
distance=0.0
incl=0.0
PA=0.0
vsys=0.0
#import galaxy data including mge terms
n_mge=0
n_HI_mge=0
#i_MC=10
f = open(fl_mge, 'r')
line = f.readline()
nm_prefix=line.split()[0]
fl_dat=nm_prefix+'_vlos_fit4.in'
fl_HI=nm_prefix+'_vHI_mge.in'
fl_out=nm_prefix+'_pdf_sample.out'
line = f.readline()
cline=line.split()
distance=float(cline[0])
incl=float(cline[1])
PA=float(cline[2])
vsys=float(cline[3])
line = f.readline()
n_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_mge_surf=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_mge_sigma=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_mge_qobs=np.array(line.split(),dtype=np.double)
f.close()
mge_surf=pl_mge_surf
mge_sigma=pl_mge_sigma
mge_qobs=pl_mge_qobs
#import kinematic data
n_data=0
f = open(fl_dat, 'r')
pl_x1_pos=[]
pl_y1_pos=[]
pl_vobs=[]
pl_evobs=[]
for line in f:
    line = line.strip()
    columns = line.split()
    pl_x1_pos.append(float(columns[0]))
    pl_y1_pos.append(float(columns[1]))
    pl_vobs.append(float(columns[3]))
    pl_evobs.append(float(columns[4]))
f.close()
n_data=len(pl_x1_pos)
x1_pos=np.array(pl_x1_pos)
y1_pos=np.array(pl_y1_pos)
vobs=np.array(pl_vobs)
#evobs=np.array(pl_evobs)+np.ones(n_data)*vsyserr
evobs=np.array(pl_evobs)
#x1_pos=(ctypes.c_double*len(pl_x1_pos))(*pl_x1_pos)
#y1_pos=(ctypes.c_double*len(pl_y1_pos))(*pl_y1_pos)
#vobs=(ctypes.c_double*len(pl_vobs))(*pl_vobs)
#evobs=(ctypes.c_double*len(pl_evobs))(*pl_evobs)

#import HI data
f = open(fl_HI, 'r')
line = f.readline()
n_HI_mge=line.split()[0]
line = f.readline()
#convert list to python array
pl_surf_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_sigma_mge_HI=np.array(line.split(),dtype=np.double)
line = f.readline()
pl_qobs_mge_HI=np.array(line.split(),dtype=np.double)
f.close()
surf_mge_HI=pl_surf_mge_HI
sigma_mge_HI=pl_sigma_mge_HI
qobs_mge_HI=pl_qobs_mge_HI
tmp1=np.sum(surf_mge_HI)
if tmp1 >= 0.0:
   iHI=1
else:
   iHI=0

out1=0.0
f = open('soln_tmp.in', 'r')
line = f.readline()
f.close()
star_pars0=np.array(line.split(),dtype=np.double)
#star_pars0=np.array([11.150311,17.400028,0.78758400,1.0478867,54.537854,62.351739,596.70274,0.93774576,-0.23199544,5.4127528]) #N959 gas
#star_pars0=np.array([11.805633,19.497401,0.83347414,0.93434102,27.587521,160.35875,582.17597,-1.1096576,0.67616568,6.1825010]) #U2259 gas
#star_pars0=np.array([11.300153,17.150230,0.38960536,1.1777088,56.343327,57.763478,521.94404,0.97871346,1.4156085,5.7361057]) #N2552 gas
#star_pars0=np.array([12.162993,19.164215,0.34767406,0.78835920,61.620985,-33.730865,4.8362845,-1.1941633,-2.4339967,6.8519074]) #N2976 gas
#star_pars0=np.array([11.345129,19.422910,0.82988827,1.1225982,46.383311,170.76779,201.50952,-0.91183835,-0.66266586,6.5422149]) #N5204 gas
#star_pars0=np.array([11.736160,19.056096,0.52259871,1.0415212,61.108071,148.60672,442.18963,1.0435687,0.37143844,5.1920238]) #N5949 gas
#star_pars0=np.array([11.306975,16.080179,0.40144560,1.1940406,67.568294,56.652648,899.52890,1.2756769,0.25187158,7.2770101]) #U11707 gas
chisq1=vw.sub_eval_gas(star_pars0,x1_pos,y1_pos,
vobs,evobs,mge_surf,mge_sigma,mge_qobs,surf_mge_HI,sigma_mge_HI,qobs_mge_HI,
distance,incl,PA,vsys,out1)
#sz_arr=len(vobs)
#print chisq1, sz_arr

#tchi=[]
#fo=open('chisqout.txt',"a")
#random.seed(0)
#dat_st1=np.genfromtxt('pr2'+nm_prefix+'_gaspdf_sample.out')
#dat_st1[:,np.shape(dat_st1)[1]-1]=np.ones(np.shape(dat_st1)[0])*sigsys
#for i in range(1001):
#   inow=int(np.shape(dat_st1)[0]*random.random())
#   chisq1=vw.sub_eval_gas(dat_st1[inow,:],x1_pos,y1_pos,
#vobs,evobs,mge_surf,mge_sigma,mge_qobs,surf_mge_HI,sigma_mge_HI,qobs_mge_HI,
#distance,incl,PA,vsys,out1)
#   tchi.append(chisq1)
#fo.write("{0} {1} {2}\n".format(min(tchi),float(sum(tchi))/len(tchi),np.median(tchi)))
#fo.close()





