program loop_jam
!-----------------------------------------------
!Top level code to read in the kinematics for a VW galaxy and find the best
!model
use mod_jammin
use rot_cur_mod
Implicit None
Integer::ijunk1,ijunk2,iHI
Real::rjunk1,rjunk2,rjunk3,rjunk4,rjunk5,rjunk6,syserr,ML_now,inc_now,beta_now,&
dm_gamma,t1,t2,min_inc,tmp_chisq,inc_orig
Real,allocatable,dimension(:)::vmodel,vfibmodel,tmp1,tmp2,tmp3
Character::filein1*150,filein2*150,fmt1*95,filein3*95
Integer::i,j,k,n_fit,status1,i_status,n_mge,n0_HI,icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7,&
jlo,j1,j2,k1,k2,k3,k4,k5
Parameter (n_fit=7)
Real::a_terms(n_fit),a_out(n_fit),a_err(n_fit),&
distance,incl,PA,vsys,d_scale,M200,cval,dx_grid(n_fit),x0_grid(n_fit),p_val(n_fit),&
lik_norm
Integer::n_grid(n_fit)
Parameter(n_grid=(/5,5,5,5,5,5,5/),dx_grid=(/0.6,3.0,0.2,0.2,1.0,0.3,4.0/))
Real::lik_grid(n_grid(1),n_grid(2),n_grid(3),n_grid(4),n_grid(5),n_grid(6),n_grid(7)),&
p_prior12(n_grid(1),n_grid(2)),p_prior3(n_grid(3)),p_prior4(n_grid(4)),p_prior5(n_grid(5)),&
p_prior6(n_grid(6)),p_prior7(n_grid(7)),M200_now,c_now,x0,y0,dm_params(3),&
pmarg(n_fit,2)
Real,Allocatable,Dimension(:)::x1_pos,y1_pos,vobs,evobs,v_stel,v_HI,&
mge_surf,mge_sigma,mge_qobs,r0_HI,v0_HI,r_pos,psi_pos,v_dm,v_circ

iHI=1
x0_grid=(/8.5,16.0,0.0,0.3,10.0,-1.0,0.0/)
!params are logM200, c, gamma, Upsilon, i, beta_z, vsys

filein3="loop_jam.in"
lik_grid(:,:,:,:,:,:,:)=0.0
!Open file of x, y, vobs, verr
!Enter MGE parameters
status1=0
Open(21,file="loop_jam.in",iostat=status1)
IF (status1.ne.0) STOP "No such file vlos_mge.in exists."
Read(21,*) distance, incl, PA, vsys
d_scale=distance*3.14159d-3/0.648 !Constant factor to convert arcsec --> kpc
!Angles in degrees
Read(21,*) n_mge
Allocate(mge_surf(n_mge),mge_sigma(n_mge),mge_qobs(n_mge))
!As usual, units of Lsun/pc^2, arcsec, and none
Read(21,*) (mge_surf(i),i=1,n_mge)
Read(21,*) (mge_sigma(i),i=1,n_mge)
Read(21,*) (mge_qobs(i),i=1,n_mge)
Close(21)
x0_grid(5)=incl-dx_grid(5)*real((n_grid(5)-1)/2.)
x0_grid(7)=vsys-dx_grid(7)*real((n_grid(7)-1)/2.)
status1=0

!sigmapsf=0.0 !arcsec
!pixsize=0.0 !fiber diameter
sigmapsf=0.8 !arcsec
pixsize=3.04 !fiber diameter
syserr=1.0 !km/s

filein1="loop_jam_data.in"
status1=0
open(21,file=filein1,iostat=status1)
IF (status1.ne.0) STOP "No such input file exists."
nfib=0
ndata=0
Read(21,*,iostat=status1) ijunk1,ijunk2
if (status1.ne.0) STOP "No such input file exists."
nfib=nfib+1
if (ijunk2.gt.ndata) ndata=ijunk2
Do
   Read(21,*,iostat=status1) ijunk1,ijunk2
   if (status1.ne.0) exit
   nfib=nfib+1
   if (ijunk2.gt.ndata) ndata=ijunk2
End Do
Close(21)
Allocate(xfib(nfib),yfib(nfib),gamfib(nfib),indfib(nfib),vdata(ndata),v_circ(ndata),evdata(ndata),vmodel(ndata),&
vfibmodel(nfib))
open(21,file=filein1,position="rewind")
Do i=1,nfib
   read(21,*) ijunk1, indfib(i), rjunk1, rjunk2, rjunk3, xfib(i), yfib(i), &
rjunk4, rjunk5, rjunk6
   gamfib(i)=rjunk3**2/rjunk6
   vdata(indfib(i))=rjunk1
   evdata(indfib(i))=rjunk2+syserr
End Do
close(21)

!Setup prior
!Want a constant prior in mass, but the steps are for u=log10(M200). 
!du=(dM200/M200)/ln(10), so prior \propto M200. 

rjunk1=0.0
Do i=1,n_grid(1)
   M200_now=10.**(x0_grid(1)+dx_grid(1)*real(i-1))
   Do j=1,n_grid(2)
      c_now=x0_grid(2)+dx_grid(2)*real(j-1)
      p_prior12(i,j)=(M200_now)*exp(-0.5*((c_now-&
9.6*(M200_now/1.857d12)**(-0.075))/(0.3454*c_now))**2)
!Delta_log10c=0.15 per Coe'10
      rjunk1=rjunk1+p_prior12(i,j)
   End Do
End Do

p_prior12(:,:)=p_prior12(:,:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(3)
   p_prior3(i)=1.0
   rjunk1=rjunk1+p_prior3(i)
End Do
p_prior3(:)=p_prior3(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(4)
   p_prior4(i)=1.0
   rjunk1=rjunk1+p_prior4(i)
End Do
p_prior4(:)=p_prior4(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(5)
   p_prior5(i)=exp(-0.5*((x0_grid(5)+dx_grid(5)*real(i-1)-incl)/2.0)**2)
   rjunk1=rjunk1+p_prior5(i)
End Do
p_prior5(:)=p_prior5(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(6)
   p_prior6(i)=exp(-0.5*((x0_grid(6)+dx_grid(6)*real(i-1)-PA)/2.0)**2)
   rjunk1=rjunk1+p_prior6(i)
End Do
p_prior6(:)=p_prior6(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(7)
   p_prior7(i)=exp(-0.5*((x0_grid(7)+dx_grid(7)*real(i-1)-vsys)/2.0)**2)
   rjunk1=rjunk1+p_prior7(i)
End Do
p_prior7(:)=p_prior7(:)/rjunk1
!Interpolate HI curve

lik_norm=0.0
pmarg(:,:)=0.0
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt6=1,n_grid(6)
!write(*,*) "Pgrid ", icnt5, icnt6
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
!Evaluate MGE model at positions; must be redone at every inc and PA
      Do icnt1=1,n_grid(1)
!write(*,*) "Pgrid ", icnt5, icnt6, icnt1
         p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
         dm_params(1)=10.0**p_val(1)
         Do icnt2=1,n_grid(2)
            p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
            dm_params(2)=p_val(2)
            Do icnt3=1,n_grid(3)
               p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
               dm_params(3)=p_val(3)
               Do icnt4=1,n_grid(4)
                  p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
                  call gen_jam_model(p_val(4),p_val(5),p_val(6),p_val(2),p_val(1),p_val(3),&
distance,sigmapsf,pixsize,ndata,vmodel,vfibmodel,nfib,xfib,yfib,gamfib,indfib,n_mge,&
mge_surf,mge_sigma,mge_qobs,iHI)

                  Do icnt7=1,n_grid(7)
                     p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
!Evaluate likelihood grid
                     Do i=1,ndata
                        v_circ(i)=vmodel(i)+p_val(7)
                        lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)=&
lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)+exp(-0.5*((v_circ(i)-vdata(i))/evdata(i))**2)
                     End Do
                     lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)=lik_grid(icnt1,icnt2,&
icnt3,icnt4,icnt5,icnt6,icnt7)*p_prior12(icnt1,&
icnt2)*p_prior3(icnt3)*p_prior4(icnt4)*p_prior5(icnt5)*p_prior6(icnt6)*p_prior7(icnt7)
                     rjunk1=lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)
                     lik_norm=lik_norm+rjunk1
                     pmarg(1,1)=pmarg(1,1)+p_val(1)*rjunk1
                     pmarg(1,2)=pmarg(1,2)+p_val(1)**2*rjunk1
                     pmarg(2,1)=pmarg(2,1)+p_val(2)*rjunk1
                     pmarg(2,2)=pmarg(2,2)+p_val(2)**2*rjunk1
                     pmarg(3,1)=pmarg(3,1)+p_val(3)*rjunk1
                     pmarg(3,2)=pmarg(3,2)+p_val(3)**2*rjunk1
                     pmarg(4,1)=pmarg(4,1)+p_val(4)*rjunk1
                     pmarg(4,2)=pmarg(4,2)+p_val(4)**2*rjunk1
                     pmarg(5,1)=pmarg(5,1)+p_val(5)*rjunk1
                     pmarg(5,2)=pmarg(5,2)+p_val(5)**2*rjunk1
                     pmarg(6,1)=pmarg(6,1)+p_val(6)*rjunk1
                     pmarg(6,2)=pmarg(6,2)+p_val(6)**2*rjunk1
                     pmarg(7,1)=pmarg(7,1)+p_val(7)*rjunk1
                     pmarg(7,2)=pmarg(7,2)+p_val(7)**2*rjunk1
                  End Do
               End Do
            End Do
         End Do
      End Do
   End Do
End Do
!Evaluate likelihood grid
lik_grid(:,:,:,:,:,:,:)=lik_grid(:,:,:,:,:,:,:)/lik_norm
Do i=1,n_fit
   pmarg(i,1)=pmarg(i,1)/lik_norm
   pmarg(i,2)=sqrt(max(pmarg(i,2)/lik_norm-pmarg(i,1)**2,1.d-6))
End Do
Open(83,file="pmarg_loop_jam.out")
Do i=1,n_fit
   write(83,*) pmarg(i,1), pmarg(i,2)
End Do
Close(83)
!Output most likely model
!There will be (7 2)=21 2d output grids. The inner loop will go through 
!operate on the second parameters, so they're ordered like M200,c then 
!M200,gamma then M200,Upsilon... until c,gamm...
Open(83,file="pmarg2d_loop_jam.out")
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt2=1,n_grid(2)
      p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
      write(83,*) p_val(1), p_val(2), sum(lik_grid(icnt1,icnt2,:,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt3=1,n_grid(3)
      p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
      write(83,*) p_val(1), p_val(3), sum(lik_grid(icnt1,:,icnt3,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(1), p_val(4), sum(lik_grid(icnt1,:,:,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(1), p_val(5), sum(lik_grid(icnt1,:,:,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(1), p_val(6), sum(lik_grid(icnt1,:,:,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(1), p_val(7), sum(lik_grid(icnt1,:,:,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt3=1,n_grid(3)
      p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
      write(83,*) p_val(2), p_val(3), sum(lik_grid(:,icnt2,icnt3,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(2), p_val(4), sum(lik_grid(:,icnt2,:,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(2), p_val(5), sum(lik_grid(:,icnt2,:,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(2), p_val(6), sum(lik_grid(:,icnt2,:,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(2), p_val(7), sum(lik_grid(:,icnt2,:,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(3), p_val(4), sum(lik_grid(:,:,icnt3,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(3), p_val(5), sum(lik_grid(:,:,icnt3,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(3), p_val(6), sum(lik_grid(:,:,icnt3,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(3), p_val(7), sum(lik_grid(:,:,icnt3,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(4), p_val(5), sum(lik_grid(:,:,:,icnt4,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(4), p_val(6), sum(lik_grid(:,:,:,icnt4,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(4), p_val(7), sum(lik_grid(:,:,:,icnt4,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(5), p_val(6), sum(lik_grid(:,:,:,:,icnt5,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(5), p_val(7), sum(lik_grid(:,:,:,:,icnt5,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt6=1,n_grid(6)
   p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(6), p_val(7), sum(lik_grid(:,:,:,:,:,icnt6,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Close(83)

!Output best model for visualization.
p_val(1)=pmarg(1,1)
p_val(2)=pmarg(2,1)
p_val(3)=pmarg(3,1)
p_val(4)=pmarg(4,1)
p_val(5)=pmarg(5,1)
p_val(6)=pmarg(6,1)
p_val(7)=pmarg(7,1)
call gen_jam_model(p_val(4),p_val(5),p_val(6),p_val(2),p_val(1),p_val(3),&
distance,sigmapsf,pixsize,ndata,vmodel,vfibmodel,nfib,xfib,yfib,gamfib,indfib,n_mge,&
mge_surf,mge_sigma,mge_qobs,iHI)
Open(83,file="pmodel_loop_jam.out")
Do i=1,nfib
   write(83,*) xfib(i), yfib(i), vdata(indfib(i)), vmodel(indfib(i)), p_val(7)
End Do
Close(83)

Deallocate(indfib,xfib,yfib,gamfib,vdata,v_circ,evdata,vmodel,vfibmodel)
Deallocate(mge_surf,mge_sigma,mge_qobs)
stop
end program loop_jam
