FCOMPILER	= gfortran

EXE_PATH	= ../bin
LIB_FITSIO_PATH	= $(FITSIO_LIBRARY_PATH)
LIB_NUMREC_PATH	= $(NUMREC2_LIBRARY_PATH)
# Set your Compiler flags
CFLAGS		= -c -O3 -fdefault-real-8 -fPIC
LFLAGS		= -O3 -fno-backslash
DEBUG		= -g
# Set your Compiler type
COMPILER	= $(FCOMPILER) $(CFLAGS)
LINKER		= $(FCOMPILER) $(LFLAGS)
#	example make -f Makefile - version=debug
#	if no version is given then the default is no debug, hyperfast
ifeq "$(version)" "debug"
COMPILER	= $(FCOMPILER) -c -g
LINKER		= $(FCOMPILER) -g
endif
GALAHADDIR = /export/data1/jjadams/repos/galahad
GALAHADTYPE= pc.lnx.gfo/double

#LIST OF OBJECT FILES FOR THE BUILD	
# list only the file with .o suffix
#/home/grad68/gblanc/HETDEX/vp_reduction/lib/pglib/libpgplot.a \
# If using global modules, they should be 1st on the list

COLL_P4 = 	rot_cur_subs.o\
		sub_eval_gas.o\
		conmin.o\
		nnls.o\
		mge_fit_1d.o\
                dqxgs.o\
                specfunc_beta.o\
		jam_axisymmetric_rms.o\
		wrap_eval_gas.o

#COLL_P5 = 	rot_cur_subs.o\
#		conmin.o\
#		mge_fit_1d.o\
#		dqxgs.o\
#		specfunc_beta.o\
#		jam_axisymmetric_rms.o\
#		loop_jam.o

ALL_LIBS = $(LIB_NUMREC_PATH)

ALL =	$(COLL_P4)

do_progs:$(ALL)

.SUFFIXES:.f90 .f

.f90.o:
	$(COMPILER) -o $@ $<
.f.o:
	$(COMPILER) -o $@ $<
