Pro resamp_plot_model, nm_in
;Takes systemic velocity. Resamples abs gas vel map to stellar bin coords, compares to either 
;abs stel vel or second moment, and plots difference. Looking for sources of discrepant rotation curves. 
sauron_colormap
file1_name=nm_in+'.hid2.gas.in'
file2_name=nm_in+'.hid2.star.in'
;vsys=595.67331 ;from stars
;PA=61.518383
!P.CHARSIZE=1.3
!P.CHARTHICK=1.3
nlines1=file_lines(file1_name)
nlines2=file_lines(file2_name)
res_vel=dindgen(nlines1)
;write(74,*) trxfib(j), tryfib(j), v1_tmp, ev1_tmp, vrmsmodel(i)
readcol, file1_name, trxfib, tryfib, vdat, verr, vgas, format='(D,D,D,D,D)', /silent
readcol, file2_name, trxfib1a, trxfib2a, vstar, format='(D,D,X,X,D)', /silent

vel_med1=median((vdat-vgas)^2/verr^2)
vel_sig1=sigma((vdat-vgas)^2/verr^2)
vel_med2=median((vdat-vstar)^2/verr^2)
vel_sig2=sigma((vdat-vstar)^2/verr^2)

fib_rad=1.56d0
;readcol, file1_name, xb1, yb1, data1, data2, data3
set_plot, 'ps'
device, filename=nm_in+'_resamp_model.eps',/color, XSIZE=20, YSIZE=10
ncolors=128
display_overlap_fibers, trxfib, tryfib, (vdat-vgas)^2/verr^2, FIBERSIZE=fib_rad, $
RANGE=[vel_med1-3.0*vel_sig1,vel_med1+3.0*vel_sig1], POSITION=[15d-2, 15d-2, 0.85d0, 0.85d0], title=nm_in
colorbar, position=[0.86d0, 0.1d0, 0.9d0, 0.8d0], /VERTICAL, /RIGHT, $
RANGE=[vel_med1-3.0*vel_sig1,vel_med1+3.0*vel_sig1], TITLE='km s!U-1!N'
display_overlap_fibers, trxfib, tryfib, (vdat-vstar)^2/verr^2, FIBERSIZE=fib_rad, $
RANGE=[vel_med2-3.0*vel_sig2,vel_med2+3.0*vel_sig2], POSITION=[15d-2, 15d-2, 0.85d0, 0.85d0], title=nm_in
colorbar, position=[0.86d0, 0.1d0, 0.9d0, 0.8d0], /VERTICAL, /RIGHT, $
RANGE=[vel_med2-3.0*vel_sig2,vel_med2+3.0*vel_sig2], TITLE='km s!U-1!N'
device, /close
set_plot, 'x'
END
