Program rot_cur_fit4
!New code on 9/13/13. The gas fits are crumby when extracted as rotation curves. 
!Now just evaluating all parameters on grid of Bayesian probabilities in native, 
!on-sky units. Entering HI rotation curves still as a grid to be interpolated. 
!Emulating Cappellari mge_circular_velocity to put MGE terms into vrot. Input
!file is same format as vdV's IDL code (vlos_?????.dat files) with 
!del ra, del dec ("), A/N, v, e_v, dither, fiber (last two unused).
!Parameter grid is log10(M200), c, gamma, Upsilon, i, PA, vsys
use rot_cur_mod
IMPLICIT NONE
Integer::i,j,k,n_fit,status1,i_status,n_mge,n0_HI,icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7,&
jlo,j1,j2,k1,k2,k3,k4,k5
Parameter (n_fit=7)
Real::rjunk1,rjunk2,rjunk3,a_terms(n_fit),a_out(n_fit),a_err(n_fit),&
distance,incl,PA,vsys,d_scale,M200,cval,dx_grid(n_fit),x0_grid(n_fit),p_val(n_fit),&
lik_norm
Integer::n_grid(n_fit)
Parameter(n_grid=(/11,11,11,11,11,11,11/),dx_grid=(/0.3,1.5,0.1,0.1,0.5,1.0,2.0/))
Real::lik_grid(n_grid(1),n_grid(2),n_grid(3),n_grid(4),n_grid(5),n_grid(6),n_grid(7)),&
p_prior12(n_grid(1),n_grid(2)),p_prior3(n_grid(3)),p_prior4(n_grid(4)),p_prior5(n_grid(5)),&
p_prior6(n_grid(6)),p_prior7(n_grid(7)),M200_now,c_now,x0,y0,dm_params(3),&
pmarg(n_fit,2)
Real,Allocatable,Dimension(:)::x1_pos,y1_pos,vobs,evobs,v_stel,v_HI,&
mge_surf,mge_sigma,mge_qobs,r0_HI,v0_HI,r_pos,psi_pos,v_dm,v_circ

x0_grid=(/8.5,16.0,0.0,0.3,10.0,10.0,0.0/)
x0=0.0
y0=0.0
lik_grid(:,:,:,:,:,:,:)=0.0
!Open file of x, y, vobs, verr
!Enter MGE parameters
status1=0
Open(21,file="vlos_mge.in",iostat=status1)
IF (status1.ne.0) STOP "No such file vlos_mge.in exists."
Read(21,*) distance, incl, PA, vsys
d_scale=distance*3.14159d-3/0.648 !Constant factor to convert arcsec --> kpc
!Angles in degrees
Read(21,*) n_mge
Allocate(mge_surf(n_mge),mge_sigma(n_mge),mge_qobs(n_mge))
!As usual, units of Lsun/pc^2, arcsec, and none
Read(21,*) (mge_surf(i),i=1,n_mge)
Read(21,*) (mge_sigma(i),i=1,n_mge)
Read(21,*) (mge_qobs(i),i=1,n_mge)
Close(21)
x0_grid(5)=incl-dx_grid(5)*real((n_grid(5)-1)/2.)
x0_grid(6)=PA-dx_grid(6)*real((n_grid(6)-1)/2.)
x0_grid(7)=vsys-dx_grid(7)*real((n_grid(7)-1)/2.)
status1=0
n_data=0
Open(21,file="vlos_fit4.in",iostat=status1)
IF (status1.ne.0) STOP "No such file vlos_fit4.in exists."
Do
   read(21,*,iostat=status1) rjunk1
   if (status1.ne.0) exit
   n_data=n_data+1
End Do
Close(21)
status1=0
Allocate(x1_pos(n_data),y1_pos(n_data),vobs(n_data),evobs(n_data),v_stel(n_data),&
v_HI(n_data),r_pos(n_data),psi_pos(n_data),v_dm(n_data),v_circ(n_data))
Open(21,file="vlos_fit4.in",position="rewind")
Do i=1,n_data
   read(21,*) x1_pos(i), y1_pos(i), rjunk1, vobs(i), evobs(i)
   x1_pos(i)=x1_pos(i)
   y1_pos(i)=y1_pos(i)
   evobs(i)=evobs(i)+2.
End Do
Close(21)

!Enter HI curve
status1=0
n0_HI=0
Open(21,file="vlos_HI.in",iostat=status1)
IF (status1.ne.0) STOP "No such file vlos_HI.in exists."
Do
   read(21,*,iostat=status1) rjunk1
   if (status1.ne.0) exit
   n0_HI=n0_HI+1
End Do
Close(21)
Allocate(r0_HI(n0_HI),v0_HI(n0_HI))
status1=0
Open(21,file="vlos_HI.in",position="rewind")
Do i=1,n0_HI
   read(21,*) r0_HI(i), v0_HI(i)
End Do
Close(21)
!Setup prior
!Want a constant prior in mass, but the steps are for u=log10(M200). 
!du=(dM200/M200)/ln(10), so prior \propto M200. 

rjunk1=0.0
Do i=1,n_grid(1)
   M200_now=10.**(x0_grid(1)+dx_grid(1)*real(i-1))
   Do j=1,n_grid(2)
      c_now=x0_grid(2)+dx_grid(2)*real(j-1)
      p_prior12(i,j)=(M200_now)*exp(-0.5*((c_now-&
9.6*(M200_now/1.857d12)**(-0.075))/(0.3454*c_now))**2)
!Delta_log10c=0.15 per Coe'10
      rjunk1=rjunk1+p_prior12(i,j)
   End Do
End Do

p_prior12(:,:)=p_prior12(:,:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(3)
   p_prior3(i)=1.0
   rjunk1=rjunk1+p_prior3(i)
End Do
p_prior3(:)=p_prior3(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(4)
   p_prior4(i)=1.0
   rjunk1=rjunk1+p_prior4(i)
End Do
p_prior4(:)=p_prior4(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(5)
   p_prior5(i)=exp(-0.5*((x0_grid(5)+dx_grid(5)*real(i-1)-incl)/2.0)**2)
   rjunk1=rjunk1+p_prior5(i)
End Do
p_prior5(:)=p_prior5(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(6)
   p_prior6(i)=exp(-0.5*((x0_grid(6)+dx_grid(6)*real(i-1)-PA)/2.0)**2)
   rjunk1=rjunk1+p_prior6(i)
End Do
p_prior6(:)=p_prior6(:)/rjunk1
rjunk1=0.0
Do i=1,n_grid(7)
   p_prior7(i)=exp(-0.5*((x0_grid(7)+dx_grid(7)*real(i-1)-vsys)/2.0)**2)
   rjunk1=rjunk1+p_prior7(i)
End Do
p_prior7(:)=p_prior7(:)/rjunk1
!Interpolate HI curve

lik_norm=0.0
pmarg(:,:)=0.0
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt6=1,n_grid(6)
!write(*,*) "Pgrid ", icnt5, icnt6
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
!Evaluate MGE model at positions; must be redone at every inc and PA
      call deproj_pos(n_data,x1_pos,y1_pos,x0,y0,p_val(6),p_val(5),r_pos,psi_pos)
      call mge_circ_vel(n_mge,mge_surf,mge_sigma,mge_qobs,p_val(5),distance,n_data,&
r_pos,v_stel)
!Interpolate HI curve
      Do i=1,n_data
         jlo=nint((n0_HI-1)/2.0)
         call hunt(r0_HI,n0_HI,r_pos(i),jlo)
         j=min(max(jlo,1),n0_HI-1)
         v_HI(i)=((r0_HI(j+1)-r_pos(i))*v0_HI(j)+(r_pos(i)-r0_HI(j))*v0_HI(j+1))&
/(r0_HI(j+1)-r0_HI(j))
      End Do
      Do icnt1=1,n_grid(1)
!write(*,*) "Pgrid ", icnt5, icnt6, icnt1
         p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
         dm_params(1)=10.0**p_val(1)
         Do icnt2=1,n_grid(2)
            p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
            dm_params(2)=p_val(2)
            Do icnt3=1,n_grid(3)
               p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
               dm_params(3)=p_val(3)
               call func_sing_velrot(3,dm_params,n_data,r_pos,v_dm,distance)
               Do icnt4=1,n_grid(4)
                  p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
                  Do icnt7=1,n_grid(7)
                     p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
!Evaluate likelihood grid
                     Do i=1,n_data
                        v_circ(i)=sqrt(v_HI(i)**2+p_val(4)*v_stel(i)**2+v_dm(i)**2)*&
cos(psi_pos(i))*sin(p_val(5)*my_pi/180.0)+p_val(7)
                        lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)=&
lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)+exp(-0.5*((v_circ(i)-vobs(i))/evobs(i))**2)
                     End Do
                     lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)=lik_grid(icnt1,icnt2,&
icnt3,icnt4,icnt5,icnt6,icnt7)*p_prior12(icnt1,&
icnt2)*p_prior3(icnt3)*p_prior4(icnt4)*p_prior5(icnt5)*p_prior6(icnt6)*p_prior7(icnt7)
                     rjunk1=lik_grid(icnt1,icnt2,icnt3,icnt4,icnt5,icnt6,icnt7)
                     lik_norm=lik_norm+rjunk1
                     pmarg(1,1)=pmarg(1,1)+p_val(1)*rjunk1
                     pmarg(1,2)=pmarg(1,2)+p_val(1)**2*rjunk1
                     pmarg(2,1)=pmarg(2,1)+p_val(2)*rjunk1
                     pmarg(2,2)=pmarg(2,2)+p_val(2)**2*rjunk1
                     pmarg(3,1)=pmarg(3,1)+p_val(3)*rjunk1
                     pmarg(3,2)=pmarg(3,2)+p_val(3)**2*rjunk1
                     pmarg(4,1)=pmarg(4,1)+p_val(4)*rjunk1
                     pmarg(4,2)=pmarg(4,2)+p_val(4)**2*rjunk1
                     pmarg(5,1)=pmarg(5,1)+p_val(5)*rjunk1
                     pmarg(5,2)=pmarg(5,2)+p_val(5)**2*rjunk1
                     pmarg(6,1)=pmarg(6,1)+p_val(6)*rjunk1
                     pmarg(6,2)=pmarg(6,2)+p_val(6)**2*rjunk1
                     pmarg(7,1)=pmarg(7,1)+p_val(7)*rjunk1
                     pmarg(7,2)=pmarg(7,2)+p_val(7)**2*rjunk1
                  End Do
               End Do
            End Do
         End Do
      End Do
   End Do
End Do
!Evaluate likelihood grid
lik_grid(:,:,:,:,:,:,:)=lik_grid(:,:,:,:,:,:,:)/lik_norm
Do i=1,n_fit
   pmarg(i,1)=pmarg(i,1)/lik_norm
   pmarg(i,2)=sqrt(max(pmarg(i,2)/lik_norm-pmarg(i,1)**2,1.d-6))
End Do
Open(83,file="pmarg_rot_cur.out")
Do i=1,n_fit
   write(83,*) pmarg(i,1), pmarg(i,2)
End Do
Close(83)
!Output most likely model
!There will be (7 2)=21 2d output grids. The inner loop will go through 
!operate on the second parameters, so they're ordered like M200,c then 
!M200,gamma then M200,Upsilon... until c,gamm...
Open(83,file="pmarg2d_rot_cur.out")
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt2=1,n_grid(2)
      p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
      write(83,*) p_val(1), p_val(2), sum(lik_grid(icnt1,icnt2,:,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt3=1,n_grid(3)
      p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
      write(83,*) p_val(1), p_val(3), sum(lik_grid(icnt1,:,icnt3,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(1), p_val(4), sum(lik_grid(icnt1,:,:,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(1), p_val(5), sum(lik_grid(icnt1,:,:,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(1), p_val(6), sum(lik_grid(icnt1,:,:,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt1=1,n_grid(1)
   p_val(1)=x0_grid(1)+dx_grid(1)*real(icnt1-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(1), p_val(7), sum(lik_grid(icnt1,:,:,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt3=1,n_grid(3)
      p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
      write(83,*) p_val(2), p_val(3), sum(lik_grid(:,icnt2,icnt3,:,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(2), p_val(4), sum(lik_grid(:,icnt2,:,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(2), p_val(5), sum(lik_grid(:,icnt2,:,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(2), p_val(6), sum(lik_grid(:,icnt2,:,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt2=1,n_grid(2)
   p_val(2)=x0_grid(2)+dx_grid(2)*real(icnt2-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(2), p_val(7), sum(lik_grid(:,icnt2,:,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt4=1,n_grid(4)
      p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
      write(83,*) p_val(3), p_val(4), sum(lik_grid(:,:,icnt3,icnt4,:,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(3), p_val(5), sum(lik_grid(:,:,icnt3,:,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(3), p_val(6), sum(lik_grid(:,:,icnt3,:,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt3=1,n_grid(3)
   p_val(3)=x0_grid(3)+dx_grid(3)*real(icnt3-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(3), p_val(7), sum(lik_grid(:,:,icnt3,:,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt5=1,n_grid(5)
      p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
      write(83,*) p_val(4), p_val(5), sum(lik_grid(:,:,:,icnt4,icnt5,:,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(4), p_val(6), sum(lik_grid(:,:,:,icnt4,:,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt4=1,n_grid(4)
   p_val(4)=x0_grid(4)+dx_grid(4)*real(icnt4-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(4), p_val(7), sum(lik_grid(:,:,:,icnt4,:,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt6=1,n_grid(6)
      p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
      write(83,*) p_val(5), p_val(6), sum(lik_grid(:,:,:,:,icnt5,icnt6,:))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt5=1,n_grid(5)
   p_val(5)=x0_grid(5)+dx_grid(5)*real(icnt5-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(5), p_val(7), sum(lik_grid(:,:,:,:,icnt5,:,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Do icnt6=1,n_grid(6)
   p_val(6)=x0_grid(6)+dx_grid(6)*real(icnt6-1)
   Do icnt7=1,n_grid(7)
      p_val(7)=x0_grid(7)+dx_grid(7)*real(icnt7-1)
      write(83,*) p_val(6), p_val(7), sum(lik_grid(:,:,:,:,:,icnt6,icnt7))
   End Do
End Do
write(83,*) ""
write(83,*) ""
Close(83)

!Output best model for visualization.
p_val(1)=pmarg(1,1)
p_val(2)=pmarg(2,1)
p_val(3)=pmarg(3,1)
p_val(4)=pmarg(4,1)
p_val(5)=pmarg(5,1)
p_val(6)=pmarg(6,1)
p_val(7)=pmarg(7,1)
call deproj_pos(n_data,x1_pos,y1_pos,x0,y0,p_val(6),p_val(5),r_pos,psi_pos)
call mge_circ_vel(n_mge,mge_surf,mge_sigma,mge_qobs,p_val(5),distance,n_data,&
r_pos,v_stel)
Do i=1,n_data
   jlo=nint((n0_HI-1)/2.0)
   call hunt(r0_HI,n0_HI,r_pos(i),jlo)
   j=min(max(jlo,1),n0_HI)
!Interp or extrapolate on enclosed mass, not vcirc
   if (j.ge.n0_HI) then
      v_HI(i)=v0_HI(j)
   else
      v_HI(i)=((r0_HI(j+1)-r_pos(i))*v0_HI(j)+(r_pos(i)-r0_HI(j))*&
v0_HI(j+1))/(r0_HI(j+1)-r0_HI(j))
   endif
End Do
dm_params(1)=10.0**p_val(1)
dm_params(2)=p_val(2)
dm_params(3)=p_val(3)
call func_sing_velrot(3,dm_params,n_data,r_pos,v_dm,distance)
Open(83,file="pmodel_rot_cur.out")
Do i=1,n_data
   write(83,*) x1_pos(i), y1_pos(i), vobs(i),v_HI(i)*cos(psi_pos(i))*sin(p_val(5)*my_pi/180.0), &
sqrt(p_val(4))*v_stel(i)*cos(psi_pos(i))*sin(p_val(5)*my_pi/180.0), v_dm(i)*cos(psi_pos(i))&
*sin(p_val(5)*my_pi/180.0), p_val(7)
End Do
Close(83)

Deallocate(x1_pos,y1_pos,vobs,evobs,v_stel,v_HI,mge_surf,mge_sigma,mge_qobs,r0_HI,v0_HI,&
r_pos,psi_pos,v_dm,v_circ)
Stop
End Program
