from distutils.core import setup
from distutils.extension import Extension
from Cython.Distutils import build_ext
import numpy
npy_include_dir = numpy.get_include()

ext_modules = [Extension("smgas", ["smpy_eval_gas.pyx"], 
                         include_dirs = [npy_include_dir],
                         extra_objects=["sub_eval_gas.o", "rot_cur_subs.o", "wrap_eval_gas.o", 
                         "nnls.o","conmin.o", "mge_fit_1d.o", "dqxgs.o", "specfunc_beta.o","jam_axisymmetric_rms.o",
                         "/export/data1/jjadams/lib/numrec_f/libnumrec.a","/usr/lib64/libgfortran.so.3"])]

setup(name = 'VW Gas Velocity Field Debug',
      cmdclass = {'build_ext': build_ext},
      ext_modules = ext_modules)
