module wrap_eval_gas
!to wrap sub_eval_gas for use in C and python
use iso_c_binding
use inner_func
implicit none
contains
! need to make a subroutine as only scalars can be returned
subroutine c_sub_eval_gas(gas_pars,n_data,x1_pos,y1_pos,vobs,evobs,n_mge,&
mge_surf,mge_sigma,mge_qobs,n_mge_HI,mge_surf_HI,mge_sigma_HI,mge_qobs_HI,&
distance,incl0,min_inc,PA0,vsys0,chisq1) bind(c)

integer(c_int):: i_MC
Parameter(i_MC=10)
integer(c_int), intent(in):: n_data,n_mge,n_mge_HI
real(c_double), intent(in):: x1_pos(n_data), y1_pos(n_data), vobs(n_data), evobs(n_data), &
mge_surf(n_mge), mge_sigma(n_mge), mge_qobs(n_mge), mge_surf_HI(n_mge_HI),&
mge_sigma_HI(n_mge_HI), mge_qobs_HI(n_mge_HI),gas_pars(i_MC),min_inc
real(c_double), intent(in):: distance, incl0, PA0, vsys0
real(c_double), intent(out):: chisq1

call sub_eval_gas(gas_pars,x1_pos,y1_pos,vobs,evobs,mge_surf,mge_sigma,mge_qobs,&
mge_surf_HI,mge_sigma_HI,mge_qobs_HI,distance,incl0,min_inc,PA0,vsys0,chisq1)

end subroutine c_sub_eval_gas
end module wrap_eval_gas
